<div class="d-flex justify-content-center px-2 min-vh-100 mt-5">
  <div class="col-8">
    <div class="d-flex justify-content-center flex-column gap-4">
      <ng-container *transloco="let t; prefix: 'requestOnboarding'">
        <h1 class="text-primary">{{ t('title') }}</h1>
        @if ($loading() && onboardingRequest) {
          <div>
            <lib-loader [size]=30></lib-loader>
          </div>
        } @else {
          <div class="d-flex flex-column gap-3 mx-2">
            <div *ngIf="onboardingRequest?.status?.value">
              <h5 class="fw-light">{{ t('requestStatus') }}</h5>
              <h5>{{ onboardingRequest.status.label }}</h5>
            </div>

            <div *ngIf="onboardingRequest?.rejectionCause">
              <h5 class="fw-light">{{ t('rejectionReason') }}</h5>
              <h5>{{ onboardingRequest.rejectionCause }}</h5>
            </div>

            <div class="d-flex flex-row gap-2" *ngIf="onboardingRequest && onboardingRequest.status && onboardingRequest.status.value === 'APPROVED'">
              <button type="button" mat-stroked-button (click)="fileCSRInput.click()">
                {{ t('buttonUploadCredential') }}
              </button>

              <button type="button" mat-stroked-button color="accent" (click)="downloadCredential()">
                {{ t('buttonDownloadCredential') }}
              </button>

              <input hidden (change)="onCSRSelected($event)" #fileCSRInput accept=".pem" type="file"
                     id="fileCSRInput">
            </div>

            <div *ngIf="onboardingRequest?.participantType">
              <h5 class="fw-light">{{ t('participantType') }}</h5>
              <h5>{{ onboardingRequest.participantType.label }}</h5>
            </div>

            <div *ngIf="onboardingRequest?.updateTimestamp">
              <h5 class="fw-light">{{ t('lastUpdate') }}</h5>
              <h5>{{ onboardingRequest.updateTimestamp.toString() | date: 'longDate' }}</h5>
            </div>

            <div *ngIf="onboardingRequest?.expirationTimeframe
            && onboardingRequest.status.value === 'IN_PROGRESS'">
              <h5 class="fw-light">{{ t('expirationTimeframe') }}</h5>
              <h5>{{ onboardingRequest.expirationTimeframe | date: 'medium' }}</h5>
            </div>

          </div>

          <form [formGroup]="onboardingFormGroup"
                class="d-flex flex-column gap-2">
            <ng-container formArrayName="documents">
              <div *ngFor="let fileGroup of fileFormArray.controls; let i = index">
                <div class="row border border-1 border-black p-2 m-2" [formGroupName]="i">
                  <div class="col-12">
                    <div>
                      {{ fileGroup.get('description')?.value || 'No description' }}
                    </div>
                    <mat-chip-set class="my-2">
                      <mat-chip>{{ fileGroup.get('mimeType')?.value || 'No description' }}</mat-chip>
                      <mat-chip>{{ fileGroup.get('mandatory')?.value ? 'Mandatory' : 'Not mandatory' }}</mat-chip>
                    </mat-chip-set>
                    <div class="d-flex flex-row gap-1">
                      <button *ngIf="fileGroup.get('hasContent')?.value" type="button" color="accent" mat-stroked-button (click)="downloadFile(fileGroup.get('id')?.value)">
                        <mat-icon>cloud_download</mat-icon>
                        {{ t('downloadFile') }}
                      </button>
                      <button [disabled]="onboardingRequest.status.value !== 'IN_PROGRESS'" type="button" mat-stroked-button (click)="fileInput.click()" *ngIf="roles.includes('APPLICANT')">
                        <mat-icon>cloud_upload</mat-icon>
                        {{ t('inputLabel') }}
                      </button>
                      <button [disabled]="onboardingRequest.status.value !== 'IN_PROGRESS'" *ngIf="fileGroup.get('hasContent')?.value && roles.includes('APPLICANT')" type="button" color="warn" mat-stroked-button (click)="deleteFile(fileGroup.get('id')?.value, i)">
                        <mat-icon>delete</mat-icon>
                        {{ t('deleteFile') }}
                      </button>
                    </div>

                    <input hidden (change)="onFileSelected($event, i)" #fileInput [accept]="fileGroup.get('mimeType')?.value" type="file"
                           id="file">
                    <div class="d-flex flex-row gap-2 mt-2">
                      <span class="file-name">{{ fileGroup.get('name')?.value }}</span>
                      <span class="text-secondary" *ngIf="fileGroup.get('fileSize')?.value > 0">{{ '(' + fileGroup.get('fileSize')?.value / 1000  + 'Kb)' }}</span>
                      <span class="text-secondary" *ngIf="fileGroup.get('hasContent')?.value">{{ t('lastUpdateFile') }}{{ fileGroup.get('lastUpdate')?.value | date }}</span>
                    </div>

                  </div>
                </div>
              </div>
            </ng-container>

            <div class="d-flex pt-3" *ngIf="onboardingRequest">

              <div class="d-flex pt-3" *ngIf="onboardingRequest">
                <button mat-flat-button color="accent" type="submit" id="submit"
                        [disabled]="loading || onboardingFormGroup.invalid || onboardingRequest.status.value !== 'IN_PROGRESS'"
                        (click)="onSubmit()">
                  <mat-spinner *ngIf="loading" diameter="25"></mat-spinner>
                  <span *ngIf="!loading">{{ t('button') }}</span>
                </button>
              </div>
            </div>

          </form>

          @if (onboardingRequest && onboardingRequest.status.value === 'IN_PROGRESS') {
            <hr class="py-0 my-0">

            <h5 class="fw-light">{{ t('commentsLabel') }}</h5>

            <lib-comments  labelComment="requestOnboarding.labelComment"
                           buttonComment="requestOnboarding.buttonComment"
                           emptyComment="requestOnboarding.emptyComment"
                           commentAuthor="requestOnboarding.commentAuthor"
                           (postComment)="sendPostComment($event)"
                           [comments]="onboardingRequest.comments">
            </lib-comments>
          } @else {
            @if (onboardingRequest && onboardingRequest.comments && onboardingRequest.comments.length > 0) {
              <mat-divider></mat-divider>
              <h5>{{'Comments'}}</h5>
              <div *ngFor="let comment of onboardingRequest?.comments || []">
                <h5>{{comment.content}}</h5>
                <h6 class="text-secondary">
                  {{ t('commentAuthor', {
                  author: comment.author,
                  datePost: (comment.creationTimestamp ? comment.creationTimestamp : today.toString()) | toDate | date: 'mediumDate',
                  hours: (comment.creationTimestamp ? comment.creationTimestamp : today.toString()) | toDate | date: 'shortTime'
                }) }}
                </h6>
              </div>
            }
          }
        }
      </ng-container>
    </div>
  </div>
</div>
